## $Id: test_utils.py 15176 2018-09-26 05:47:59Z henrik $
##
## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
import grok
from hurry.workflow.interfaces import IWorkflowState
from zope.component import getUtility, createObject
from waeup.kofa.students.studylevel import StudentStudyLevel
from waeup.kofa.students.tests.test_browser import StudentsFullSetup
from waeup.kofa.students.interfaces import IStudentsUtils
from waeup.kofa.students.studylevel import StudentStudyLevel
from kofacustom.edopoly.testing import FunctionalLayer

class StudentsUtilsTests(StudentsFullSetup):

    layer = FunctionalLayer

    def test_setMatricNumber(self):
        IWorkflowState(self.student).setState('school fee paid')
        site = grok.getSite()
        utils = getUtility(IStudentsUtils)
        site['configuration'].next_matric_integer = 1
        site['configuration'].next_matric_integer_2 = 1
        site['configuration'].next_matric_integer_3 = 1
        site['configuration'].next_matric_integer_4 = 1
        self.student.matric_number = None
        # nd_ft
        self.certificate.study_mode ='nd_ft'
        msg, mnumber = utils.setMatricNumber(self.student)
        self.assertEqual(self.student.matric_number, 'ESITM/fac1/dep1/04/00001')
        self.assertEqual(msg, None)
        # hnd_ft
        self.student.matric_number = None
        self.certificate.study_mode ='hnd_ft'
        msg, mnumber = utils.setMatricNumber(self.student)
        self.assertEqual(self.student.matric_number, 'ESITM/fac1/dep1/HND/04/00001')
        self.assertEqual(msg, None)
        # nd_pt
        self.student.matric_number = None
        self.certificate.study_mode ='nd_pt'
        msg, mnumber = utils.setMatricNumber(self.student)
        self.assertEqual(self.student.matric_number, 'ESITM/PT-ND/fac1/dep1/04/00001')
        self.assertEqual(msg, None)
        return
